#include "tone.h"
#include "rec.h"

double
dmix(double a, double b, double rate)
{
	return MIX(a, b, rate);
}

int
imix(int a, int b, double rate)
{
	return (int)dmix(a, b, rate);
}


void
mix(struct tone_rec *in2, double rate, struct tone_rec *ret)
{
	struct tone_rec *a = &in2[0];
	struct tone_rec *b = &in2[1];

#define MIXED(memb, i_d)	ret->memb = i_d##mix(a->memb, b->memb, rate)

	MIXED(vco.wave1, i);
	MIXED(vco.wave2, i);
	MIXED(vco.tune, i);
	MIXED(vco.mix, d);
	MIXED(vco.ring, i);
	MIXED(vco.alias_noise1, i);
	MIXED(vco.alias_noise2, i);
	MIXED(fl1.type, i);
	MIXED(fl1.freq, d);
	MIXED(fl1.Q, d);
	MIXED(env.attack, d);
	MIXED(env.decay, d);
	MIXED(env.sustain, d);
	MIXED(env.release, d);
	MIXED(level, d);
	MIXED(lfo_modu.pitch1, i);
	MIXED(lfo_modu.pitch2, i);
	MIXED(lfo_modu.filter1, i);
	MIXED(lfo_modu.filter2, i);
	MIXED(lfo.wave, i);
	MIXED(lfo.freq, d);
	MIXED(lfo.delay, d);
	MIXED(env_modu.pitch1, i);
	MIXED(env_modu.pitch2, i);
	MIXED(env_modu.filter1, i);
	MIXED(env_modu.filter2, i);
	MIXED(delay.onoff, i);
	MIXED(delay.sec, d);
	MIXED(delay.gain, d);
	MIXED(chorus, i);
}

int
main(int ac, char **av)
{

#define N	32

	struct tone_all_rec in, out;
	struct tone_rec tones[N+1];
	char names[N][8], prog_names[N][8];
	struct tones_lst_rec tones_lst[N+1];
	struct tone_compo_rec tone_compo[N][2];
	int i;

	rec_load(&in, rec_get("struct tone_all_rec"), stdin);
	
	memset(tones, 0, sizeof(tones));
	memset(tones_lst, 0, sizeof(tones_lst));
	memset(tone_compo, 0, sizeof(tone_compo));
	for(i=0; i<N; i++){
		double rate = (double)i / (N-1);		
		mix(in.tone, rate, &tones[i]);
		sprintf(names[i], "tone%d", i);
		tones[i].name = names[i];

		sprintf(prog_names[i], "%d", i);
		tones_lst[i].prog_name = prog_names[i];
		tones_lst[i].note_name = "-1 any";

		tone_compo[i][0].name = names[i];
		tone_compo[i][0].note = -1;
		tone_compo[i][0].rate = 1;
		tones_lst[i].tone_compo = tone_compo[i];
	}
	out.tone = tones;

	tones_lst[N].prog_name = "-1";
	tones_lst[N].note_name = "-1";
	tones_lst[N].tone_compo = NULL;

	out.tones_lst = tones_lst;

	rec_save(&out, rec_get("struct tone_all_rec"), stdout, 0);

	return 0;
}

/* EOF */
